"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function parser() {
  const data = _interopRequireWildcard(require("@babel/parser"));

  parser = function parser() {
    return data;
  };

  return data;
}

function _traverse() {
  const data = _interopRequireDefault(require("@babel/traverse"));

  _traverse = function _traverse() {
    return data;
  };

  return data;
}

function _generator() {
  const data = _interopRequireDefault(require("@babel/generator"));

  _generator = function _generator() {
    return data;
  };

  return data;
}

function t() {
  const data = _interopRequireWildcard(require("@babel/types"));

  t = function t() {
    return data;
  };

  return data;
}

function _prettier() {
  const data = _interopRequireDefault(require("prettier"));

  _prettier = function _prettier() {
    return data;
  };

  return data;
}

function _lodash() {
  const data = require("lodash");

  _lodash = function _lodash() {
    return data;
  };

  return data;
}

function _uppercamelcase() {
  const data = _interopRequireDefault(require("uppercamelcase"));

  _uppercamelcase = function _uppercamelcase() {
    return data;
  };

  return data;
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function insertComponentToRender(blockStatement, identifier) {
  // blockStatement: https://babeljs.io/docs/en/babel-types#blockstatement
  const body = blockStatement.body;
  const returnBlock = body.find(b => {
    return t().isReturnStatement(b);
  });

  if (t().isJSXElement(returnBlock.argument)) {
    insertComponentToElement(returnBlock.argument, identifier);
  }
}

function insertComponentToElement(element, identifier) {
  // why use upperCamelCase: a react component name must be upperCamelCase
  // https://babeljs.io/docs/en/babel-types#jsxelement
  const newElement = t().jsxElement(t().jsxOpeningElement(t().jsxIdentifier((0, _uppercamelcase().default)(identifier)), [], true), null, [], true);
  element.children.push(newElement);
}

function _default(content, {
  relativePath,
  identifier
}) {
  const ast = parser().parse(content, {
    sourceType: 'module',
    plugins: ['jsx', 'decorators-legacy', 'typescript']
  });
  (0, _traverse().default)(ast, {
    Program({
      node
    }) {
      // add import
      const body = node.body;
      const lastImportSit = (0, _lodash().findLastIndex)(body, item => {
        return t().isImportDeclaration(item);
      });
      const newImport = t().ImportDeclaration([t().ImportDefaultSpecifier(t().identifier((0, _uppercamelcase().default)(identifier)))], t().stringLiteral(relativePath));
      body.splice(lastImportSit + 1, 0, newImport);
    },

    ClassMethod({
      node
    }) {
      // for class component
      const key = node.key,
            body = node.body;

      if (t().isIdentifier(key, {
        name: 'render'
      })) {
        if (t().isBlockStatement(body)) {
          insertComponentToRender(body, identifier);
        }
      }
    },

    ExportDefaultDeclaration({
      node
    }) {
      // for purefunction component
      const declaration = node.declaration;

      if (t().isArrowFunctionExpression(declaration) || t().isFunctionDeclaration(declaration)) {
        if (t().isBlockStatement(declaration.body)) {
          insertComponentToRender(declaration.body, identifier);
        } else if (t().isJSXElement(declaration.body)) {
          insertComponentToElement(declaration.body, identifier);
        }
      }
    }

  });
  const newCode = (0, _generator().default)(ast, {}).code;
  return _prettier().default.format(newCode, {
    // format same as ant-design-pro
    singleQuote: true,
    trailingComma: 'es5',
    printWidth: 100,
    parser: 'babel'
  });
}