"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _fs() {
  const data = require("fs");

  _fs = function _fs() {
    return data;
  };

  return data;
}

function _assert() {
  const data = _interopRequireDefault(require("assert"));

  _assert = function _assert() {
    return data;
  };

  return data;
}

function _chalk() {
  const data = _interopRequireDefault(require("chalk"));

  _chalk = function _chalk() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _default(api) {
  const generators = api.service.generators,
        log = api.log;

  function generate(args = {}) {
    try {
      const name = args._[0];
      (0, _assert().default)(name, `run ${_chalk().default.cyan.underline('umi help generate')} to checkout the usage`);
      (0, _assert().default)(generators[name], `Generator ${_chalk().default.cyan.underline(name)} not found`);
      const _generators$name = generators[name],
            Generator = _generators$name.Generator,
            resolved = _generators$name.resolved;
      const generator = new Generator(args._.slice(1), _objectSpread({}, args, {
        env: {
          cwd: api.cwd
        },
        resolved: resolved || __dirname
      }));
      return generator.run().then(() => {
        log.success('');
      }).catch(e => {
        log.error(e);
      });
    } catch (e) {
      log.error(`Generate failed, ${e.message}`);
    }
  }

  function registerCommand(command, description) {
    const details = `
Examples:

  ${_chalk().default.gray('# generate page users')}
  umi generate page users

  ${_chalk().default.gray('# g is the alias for generate')}
  umi g page index

  ${_chalk().default.gray('# generate page with less file')}
  umi g page index --less
  `.trim();
    api.registerCommand(command, {
      description,
      usage: `umi ${command} type name [options]`,
      details
    }, generate);
  }

  registerCommand('g', 'generate code snippets quickly (alias for generate)');
  registerCommand('generate', 'generate code snippets quickly');
  (0, _fs().readdirSync)(`${__dirname}/generators`).filter(f => !f.startsWith('.')).forEach(f => {
    api.registerGenerator(f, {
      // eslint-disable-next-line import/no-dynamic-require
      Generator: require(`./generators/${f}`).default(api),
      resolved: `${__dirname}/generators/${f}/index`
    });
  });
}